use super::*;

pub struct FrameData {}

pub struct MeshPass {}

impl MeshPass {
    pub fn new() -> Self {
        Self {}
    }
}

impl RenderPass for MeshPass {
    type FrameData = FrameData;

    fn create_frame_data(&mut self) -> FrameData {
        FrameData {}
    }

    fn begin_frame(&mut self, data: &mut FrameData, phases: &mut PhaseList) {
        println!("MeshPass::begin_frame()");

        phases.insert_pre(PrePhase::VertexSkinning);

        phases.insert_viewport(ViewportPhase::Depth);
        phases.insert_viewport(ViewportPhase::Opaque);
        phases.insert_viewport(ViewportPhase::Transparent);
    }

    fn render_pre(&self, phase: PrePhase, data: &FrameData, cmds: &mut gpu::RenderBundleEncoder) {
        println!("MeshPass::render_pre(phase: {:?})", phase);
    }

    fn render_viewport(
        &self,
        phase: ViewportPhase,
        data: &FrameData,
        viewport: &ViewportData,
        cmds: &mut gpu::RenderBundleEncoder,
    ) {
        println!("MeshPass::render_viewport(phase: {:?})", phase);
    }
}
